hdu 1011 Starship Troopers DP

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 11929    Accepted Submission(s): 3295

Problem Description

You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and
their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern‘s structure is like a tree in such a way that there is
one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight
all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the
problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.

Input

The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively.
The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is
described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1‘s.

Output

For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.

Sample Input

5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7
-1 -1

Sample Output

50
7
#include<iostream>
#include<cstring>
#include<vector>
using namespace std;

#define M 105
vector<int>   map[M];
int val[M],xh[M];
int dp[M][M];
int vis[M];
int n,m;

void dfs(int u){
    int i,j,k,v;
    for(i=xh[u];i<=m;i++)   dp[u][i]=val[u];
    vis[u]=1;

    for(i=0;i<map[u].size();i++){
        v=map[u][i];
        if(vis[v])   continue;
        dfs(v);
        for(j=m;j>=xh[u];j--)
            for(k=1;k<=j-xh[u];k++)
                dp[u][j]=max(dp[u][j],dp[u][j-k]+dp[v][k]);
    }
}

int main(){

    while(cin>>n>>m){
        if(n==-1 && m==-1)  break;
        int i,j,x,y;

        for(i=1;i<=n;i++){
            cin>>xh[i]>>val[i];
            xh[i]=(xh[i]+19)/20;
        }
        for(i=0;i<=n;i++)
            map[i].clear();
        for(i=1;i<n;i++){
            cin>>x>>y;
            map[x].push_back(y);
            map[y].push_back(x);
        }

        if(m==0) {cout<<0<<endl;continue;}
        memset(vis,0,sizeof vis);
        memset(dp,0,sizeof dp);
        dfs(1);
        cout<<dp[1][m]<<endl;
    }
    return 0;
}
时间: 2024-11-10 00:12:44

hdu 1011 Starship Troopers DP的相关文章

HDU 1011 Starship Troopers(树形DP)

Starship Troopers Time Limit : 10000/5000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 62   Accepted Submission(s) : 12 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description You, the leader of

hdu 1011 Starship Troopers (依赖背包 树形dp)

题目: 链接:点击打开链接 题意: n个房间组成一棵树,你有m个战队,从1号房间开始依次clear每个房间,在每个房间需要花费的战队个数是bugs/20,得到的价值是the possibility of capturing a brain,求最大的价值. 算法: 树形dp,有依赖的背包问题.(依次clear每个房间) 思路: 状态转移dp[i][j]表示根结点为i时(房间i)花费j个战队能够得到的最大价值(捕捉到一个brain最大的可能值).递归求出每个根结点处的最大值,最后dp[1][m]就是

HDU 1011 Starship Troopers(树形dp+背包)

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 13109    Accepted Submission(s): 3562 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of

hdu 1011 Starship Troopers(树形DP入门)

Starship Troopers Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 17498    Accepted Submission(s): 4644 Problem Description You, the leader of Starship Troopers, are sent to destroy a base of t

HDU 1011 Starship Troopers星河战队(AC代码)树形dp

这个没有考虑过多东西的代码也是AC了. 1 #include <iostream> 2 #include <vector> 3 #define limit 110 4 using namespace std; 5 6 vector<int> vect[limit]; 7 int n,m; 8 bool vis[limit]; 9 int bug[limit],pos[limit]; 10 int dp[limit][limit]; 11 12 int max(int a

HDU 1011 Starship Troopers 树形DP 有坑点

本来是一道很水的树形DP题 设dp[i][j]表示,带着j个人去攻打以节点i为根的子树的最大收益 结果wa了一整晚 原因: 坑点1: 即使这个节点里面没有守卫,你如果想获得这个节点的收益,你还是必须派一个人去这个节点,不然谁帮你去拿收益? 坑点2: 题目说是从节点1开始攻打,然后我就以为给出的数据都是以1为根节点的,就没有加双向边 不过, 最后我加了双向边,然后还是wa了 又找了很久,最后发现是前向星的数组开小了 注意:数组开小了可能会返回wa,tle,re等等等等 1 #include<cst

树形dp/hdu 1011 Starship Troopers

题意 有n个房子,1号为起点房子.每个房子里会消耗一定的士兵来获取一定的价值.现在有m个士兵,求问可以获得的最大价值 注意:走过的房子不能再走 注意2:若要消灭这个房子的bugs,必须全部消灭 分析 典型的树形dp,01背包,因为每个房子里要么全杀死bugs,要么一个不动,只有取或不取两种状态 设f[i][j]表示以i为根节点,消耗j个士兵所能获得的最大价值 则f[i][j]=max(f[son[i]][k] + f[i][j-k]); 答案为f[1][m] Accepted Code 1 /*

hdu 1011 Starship Troopers 树dp

题目大意是有n个房间组成一棵树,你有m个士兵,从1号房间开始让士兵向相邻的房间出发,每个房间里有一个代价,代价是值/20个士兵, 同时有一个价值,问你花费这m个士兵可以得到的最大价值是多少 定义dp[i][j]表示根结点为i时,用掉j个士兵获得的最大possible. dp[i][j] = max(dp[i][j], dp[i][j-k] + dp[son[i]][k]); #include <cstdio> #include <cstring> #include <algo

hdu 1011 Starship Troopers 树形背包

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1011 题意:有n个洞,每个洞有若干虫子和脑子,洞之间相连形成一棵树.你有m个士兵,一个士兵可以打10只虫子,士兵留下后就不能走了.从一号洞开始打,求获得最多的脑子. 树形背包.如果你在某一个洞里,有m个士兵.你可以选择派遣k个士兵去攻打与洞相连的某个子树.可以先用递归算出子树的情况.这类似于背包九讲的泛化背包. 定义 考虑这样一种物品,它并没有固定的费用和价值,而是它的价值随着你分配给它的费用而变化